package com.steerinfo.meterwork.meterworkstaticmonitor.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkstaticmonitor.model.MeterWorkStaticMonitor;
import com.steerinfo.meterwork.meterworkstaticmonitor.service.IMeterWorkStaticMonitorService;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkStaticMonitor RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-12-16 08:48
 * 类描述
 * 修订历史：
 * 日期：2020-12-16
 * 作者：generator
 * 参考：
 * 描述：MeterWorkStaticMonitor RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkstaticmonitors")
public class MeterWorkStaticMonitorController extends BaseRESTfulController {

    @Autowired
    IMeterWorkStaticMonitorService meterWorkStaticMonitorService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstaticmonitor:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkStaticMonitor> list = meterWorkStaticMonitorService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstaticmonitor:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkStaticMonitor> list = meterWorkStaticMonitorService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkStaticMonitor对象创建")
    @ApiImplicitParam(name = "meterWorkStaticMonitor", value = "详细实体meterWorkStaticMonitor", required = true, dataType = "MeterWorkStaticMonitor")
    //@RequiresPermissions("meterworkstaticmonitor:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkStaticMonitor model) {
        try {
            MeterWorkStaticMonitor meterWorkStaticMonitor = meterWorkStaticMonitorService.add(model);
            return success(meterWorkStaticMonitor);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstaticmonitor:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkStaticMonitor meterWorkStaticMonitor = meterWorkStaticMonitorService.getById(id);
            return success(meterWorkStaticMonitor);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkStaticMonitor信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkStaticMonitor", value = "详细实体meterWorkStaticMonitor", required = true, dataType = "MeterWorkStaticMonitor")
    })
    //@RequiresPermissions("meterworkstaticmonitor:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkStaticMonitor model) {
        try {
            model.setId(id);
            MeterWorkStaticMonitor meterWorkStaticMonitor = meterWorkStaticMonitorService.modify(model);
            return success(meterWorkStaticMonitor);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstaticmonitor:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkStaticMonitorService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "Wf端修改数据")
    @PutMapping(value = "/update", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@RequestBody MeterWorkStaticMonitor model) {
        try {
            String no = meterWorkStaticMonitorService.update(model);
            if (StringUtils.isNotEmpty(no)) {
                return success();
            } else {
                return failed();
            }
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
